package cn.estsh.i3plus.ext.mes.pcn.pojo.util;

import com.fasterxml.jackson.annotation.JsonFormat;

public class MesPcnExtEnumUtil {


    /**
     * 装车单-状态
     */
    @JsonFormat(
            shape = JsonFormat.Shape.OBJECT
    )
    public static enum LOADING_ORDER_STATUS {
        CREATE(10, "创建"),
        LOADING(15, "装车中"),
        LOADED(20, "已装车"),
        SHIPPING(30, "已发运"),
        CLOSE(40, "关闭");

        private int value;
        private String description;


        private LOADING_ORDER_STATUS(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public static String valueOfDescription(int val) {
            String tmp = null;

            for (int i = 0; i < values().length; ++i) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }

            return tmp;
        }

        public int getValue() {
            return this.value;
        }

        public String getDescription() {
            return this.description;
        }
    }

    /**
     * 装车单明细-状态
     */
    @JsonFormat(
            shape = JsonFormat.Shape.OBJECT
    )
    public static enum LOADING_DETAIL_ORDER_STATUS {
        CREATE(10, "创建"),
        LOADED(20, "已装车"),
        SHIPPING(30, "已发运"),
        CLOSE(40, "关闭");

        private int value;
        private String description;


        private LOADING_DETAIL_ORDER_STATUS(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public static String valueOfDescription(int val) {
            String tmp = null;

            for (int i = 0; i < values().length; ++i) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }

            return tmp;
        }

        public int getValue() {
            return this.value;
        }

        public String getDescription() {
            return this.description;
        }
    }


    /**
     * 发运单状态
     */
    @JsonFormat(
            shape = JsonFormat.Shape.OBJECT
    )
    public static enum SHIPPING_ORDER_STATUS {
        CREATE(10, "创建"),
        PUBLISHED(20, "已发布"),
        SHIPPED(30, "已发运"),
        VERIFYING(35, "校验中"),
        VERIFICATION_COMPLETED(40, "校验完成");

        private int value;
        private String description;

        private SHIPPING_ORDER_STATUS(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public static String valueOfDescription(int val) {
            String tmp = null;

            for (int i = 0; i < values().length; ++i) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }

            return tmp;
        }

        public int getValue() {
            return this.value;
        }

        public String getDescription() {
            return this.description;
        }
    }


    /**
     * 装车单明细-发运状态
     */
    @JsonFormat(
            shape = JsonFormat.Shape.OBJECT
    )
    public static enum LOADING_ORDER_DETAIL_SHIPPING_STATUS {
        PUBLISHED(10, "Published"),
        SHIPPINGED(20, "Shippinged");

        private int value;
        private String description;

        private LOADING_ORDER_DETAIL_SHIPPING_STATUS(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public static String valueOfDescription(int val) {
            String tmp = null;

            for (int i = 0; i < values().length; ++i) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }

            return tmp;
        }

        public int getValue() {
            return this.value;
        }

        public String getDescription() {
            return this.description;
        }
    }

    /**
     * 零件发运组-扫描确认零件方式
     */
    @JsonFormat(
            shape = JsonFormat.Shape.OBJECT
    )
    public static enum PRODUCE_SN_STATUS {
        CREATE(10, "创建"),
        OFFLINE(20, "已完成"),
        ASSEMBLY(30, "已装配"),
        CHECKED(40, "已校验"),
        SHIPPED(50, "发运");

        private int value;
        private String description;

        private PRODUCE_SN_STATUS(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public static String valueOfDescription(int val) {
            String tmp = null;

            for (int i = 0; i < values().length; ++i) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }

            return tmp;
        }

        public int getValue() {
            return this.value;
        }

        public String getDescription() {
            return this.description;
        }
    }

    /**
     * 零件发运组-扫描确认零件方式
     */
    @JsonFormat(
            shape = JsonFormat.Shape.OBJECT
    )
    public static enum PRODUCE_QC_STATUS {
        QUALIFIED(10, "合格"),
        SUSPICIOUS(20, "可疑"),
        SCRAP(30, "报废");

        private int value;
        private String description;

        private PRODUCE_QC_STATUS(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public static String valueOfDescription(int val) {
            String tmp = null;

            for (int i = 0; i < values().length; ++i) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }

            return tmp;
        }

        public int getValue() {
            return this.value;
        }

        public String getDescription() {
            return this.description;
        }
    }


}
